
class SutoriChallengeEvent{constructor(owner,moment){this.Owner=owner;this.Moment=moment;this.ElementCount=moment.Elements.length;}
GetElements(culture,type){const elements=typeof culture=='undefined'?this.Moment.Elements.filter(e=>e instanceof type):this.Moment.Elements.filter(e=>e instanceof type&&(e.ContentCulture==culture||e.ContentCulture==SutoriCulture.All));return elements;}
GetText(culture){return this.GetElements(culture,SutoriElementText);}
GetOptions(culture){return this.GetElements(culture,SutoriElementOption);}
GetImages(culture){return this.GetElements(culture,SutoriElementImage);}
GetAudio(culture){return this.GetElements(culture,SutoriElementAudio);}
GetVideos(culture){return this.GetElements(culture,SutoriElementVideo);}}
class SutoriDocument{constructor(){this.Moments=new Array();}
static async LoadXml(uri){const result=new SutoriDocument();await result.AddMomentsFromXmlUri(uri);return result;}
async AddMomentsFromXmlUri(uri){const response=await fetch(uri);const raw_xml=await response.text();await this.AddMomentsFromXml(raw_xml);}
AddMomentsFromXml(raw_xml){const xml_parser=new DOMParser();const xml=xml_parser.parseFromString(raw_xml,"text/xml");const self=this;xml.querySelectorAll('moments moment').forEach((moment_e)=>{const moment=new SutoriMoment();if(moment_e.hasAttribute('id')){moment.ID=moment_e.attributes['id'].textContent;}
if(moment_e.hasAttribute('goto')){moment.Goto=moment_e.attributes['goto'].textContent;}
self.AddMomentAttributes(moment,moment_e,['id','goto']);moment_e.querySelectorAll('elements > *').forEach((element_e)=>{switch(element_e.tagName){case'text':moment.Elements.push(SutoriElementText.Parse(element_e));break;case'option':moment.Elements.push(SutoriElementOption.Parse(element_e));break;case'image':moment.Elements.push(SutoriElementImage.Parse(element_e));break;case'audio':moment.Elements.push(SutoriElementAudio.Parse(element_e));break;case'video':moment.Elements.push(SutoriElementVideo.Parse(element_e));}});self.Moments.push(moment);});}
AddMomentAttributes(moment,element,exclude){const self=this;for(let i=0;i<element.attributes.length;i++){const attr=element.attributes[i];if(typeof exclude!=='undefined'&&exclude.indexOf(attr.name)>-1)
continue;moment.Attributes[attr.name]=attr.value;}}
AddMoment(moment){this.Moments.push(moment);}}
class SutoriElement{ParseExtraAttributes(element,exclude){const self=this;self.Attributes=new Object;for(let i=0;i<element.attributes.length;i++){const attr=element.attributes[i];if(typeof exclude!=='undefined'&&exclude.indexOf(attr.name)>-1)
continue;self.Attributes[attr.name]=attr.value;}}}
class SutoriElementAudio extends SutoriElement{constructor(){super();this.ContentCulture=SutoriCulture.None;}
static Parse(element){const result=new SutoriElementAudio();result.Src=element.textContent;result.ParseExtraAttributes(element,['lang']);if(element.hasAttribute('lang')){const lang=element.attributes['lang'].textContent;result.ContentCulture=SutoriTools.ParseCulture(lang);}
return result;}}
class SutoriElementImage extends SutoriElement{constructor(){super();this.ContentCulture=SutoriCulture.None;}
static Parse(element){const result=new SutoriElementImage();result.Src=element.textContent;result.ParseExtraAttributes(element,['lang']);if(element.hasAttribute('lang')){const lang=element.attributes['lang'].textContent;result.ContentCulture=SutoriTools.ParseCulture(lang);}
return result;}}
class SutoriElementOption extends SutoriElement{constructor(){super();this.ContentCulture=SutoriCulture.None;this.Target=null;this.Solver=SutoriSolver.None;this.SolverCallback=null;}
static Parse(element){const result=new SutoriElementOption();result.Text=element.textContent;result.ParseExtraAttributes(element,['lang','target','solver','solver_callback']);if(element.hasAttribute('lang')){const lang=element.attributes['lang'].textContent;result.ContentCulture=SutoriTools.ParseCulture(lang);}
if(element.hasAttribute('target')){result.Target=element.attributes['target'].textContent;}
if(element.hasAttribute('solver')){const solver=element.attributes['solver'].textContent;result.Solver=SutoriTools.ParseSolver(solver);}
if(element.hasAttribute('solver_callback')){result.Target=element.attributes['solver_callback'].textContent;}
return result;}}
class SutoriElementText extends SutoriElement{constructor(){super();this.ContentCulture=SutoriCulture.None;}
static Parse(element){const result=new SutoriElementText();result.Text=element.textContent;result.ParseExtraAttributes(element,['lang']);if(element.hasAttribute('lang')){const lang=element.attributes['lang'].textContent;result.ContentCulture=SutoriTools.ParseCulture(lang);}
return result;}}
class SutoriElementVideo extends SutoriElement{constructor(){super();this.ContentCulture=SutoriCulture.None;}
static Parse(element){const result=new SutoriElementVideo();result.Src=element.textContent;result.ParseExtraAttributes(element,['lang']);if(element.hasAttribute('lang')){const lang=element.attributes['lang'].textContent;result.ContentCulture=SutoriTools.ParseCulture(lang);}
return result;}}
class SutoriEngine{constructor(document){this.Document=document;}
GotoMomentID(momentID){const moment=this.Document.Moments.find(t=>t.ID==momentID);if(moment==null)
throw new Error("Could not find moment with id #{momentID}.");this.GotoMoment(moment);}
GotoMoment(moment){if(moment==null)
moment=this.Document.Moments[0];if(moment==null)
throw new Error("Document does not have any beads!");this.Cursor=moment;this.HandleChallenge(new SutoriChallengeEvent(this,moment));}
Play(){this.GotoMoment(null);}
GotoNextMoment(){if(this.Cursor==null)
return;const index=this.Document.Moments.indexOf(this.Cursor);if(index==-1)
return;if(this.Cursor.Goto!=''){this.GotoMomentID(this.Cursor.Goto);return;}
if(index==this.Document.Moments.length-1)
return;this.GotoMoment(this.Document.Moments[index+1]);}}
class SutoriMoment{constructor(){this.Elements=new Array();this.Attributes=new Object;this.ID='';this.Goto='';}
AddText(culture,text){const element=new SutoriElementText();element.ContentCulture=culture;element.Text=text;this.Elements.push(element);return element;}
AddImage(culture,src){const element=new SutoriElementImage();element.ContentCulture=culture;element.Src=src;this.Elements.push(element);return element;}
AddAudio(culture,src){const element=new SutoriElementAudio();element.ContentCulture=culture;element.Src=src;this.Elements.push(element);return element;}
AddVideo(culture,src){const element=new SutoriElementVideo();element.ContentCulture=culture;element.Src=src;this.Elements.push(element);return element;}
AddOption(culture,text,target){const element=new SutoriElementOption();element.ContentCulture=culture;element.Text=text;element.Target=target;this.Elements.push(element);return element;}}
class SutoriTools{static ParseCulture(cultureName){var _a;const stringKey=(_a=Object.entries(SutoriCulture).find(([key,val])=>val===cultureName))===null||_a===void 0?void 0:_a[0];return SutoriCulture[stringKey];}
static ParseSolver(solverName){var _a;const stringKey=(_a=Object.entries(SutoriSolver).find(([key,val])=>val===solverName))===null||_a===void 0?void 0:_a[0];return SutoriSolver[stringKey];}}
var SutoriCulture;(function(SutoriCulture){SutoriCulture["None"]="none";SutoriCulture["All"]="all";SutoriCulture["EnUS"]="en-US";SutoriCulture["zhCN"]="zh-CN";SutoriCulture["ruRU"]="ru-RU";SutoriCulture["FrFR"]="fr-FR";SutoriCulture["esES"]="es-ES";SutoriCulture["EnGB"]="en-GB";SutoriCulture["deDE"]="de-DE";SutoriCulture["ptBR"]="pt-BR";SutoriCulture["enCA"]="en-CA";SutoriCulture["esMX"]="es-MX";SutoriCulture["itIT"]="it-IT";SutoriCulture["jaJP"]="ja-JP";})(SutoriCulture||(SutoriCulture={}));var SutoriSolver;(function(SutoriSolver){SutoriSolver["None"]="none";SutoriSolver["OptionIndex"]="option_index";SutoriSolver["KeyCharEquality"]="key_char_equality";SutoriSolver["TextEquality"]="text_equality";SutoriSolver["Custom"]="custom";})(SutoriSolver||(SutoriSolver={}));